diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicSugarcane.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicSugarcane.java
index 7cd972dc5..dff58702a 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicSugarcane.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicSugarcane.java
@@ -1,43 +1,40 @@
 package net.minecraft.core.block;
 
 import net.minecraft.core.block.entity.TileEntity;
+import net.minecraft.core.block.material.Materials;
 import net.minecraft.core.block.support.ISupport;
 import net.minecraft.core.block.support.PartialSupport;
 import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.item.IBonemealable;
 import net.minecraft.core.util.helper.Direction;
 import net.minecraft.core.util.helper.Side;
-import net.minecraft.core.util.phys.AABB;
 import net.minecraft.core.block.tag.BlockTags;
 import net.minecraft.core.enums.EnumDropCause;
 import net.minecraft.core.item.Items;
-import net.minecraft.core.block.material.Material;
 import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.WorldSource;
 import net.minecraft.core.world.pos.TilePos;
+import net.minecraft.core.world.pos.TilePosc;
 import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
+import org.joml.primitives.AABBdc;
 
 import java.util.Random;
 
-public class BlockLogicSugarcane extends BlockLogic implements IBonemealable
-{
+public class BlockLogicSugarcane extends BlockLogic implements IBonemealable {
 
-	public BlockLogicSugarcane(@NotNull Block<?> block)
-    {
-        super(block, Material.plant);
+    public BlockLogicSugarcane(@NotNull Block<?> block) {
+        super(block, Materials.PLANT);
         float f = 0.375F;
         setBlockBounds(0.5F - f, 0.0F, 0.5F - f, 0.5F + f, 1.0F, 0.5F + f);
         block.setTicking(true);
     }
 
     @Override
-	public void updateTick(@NotNull World world, @NotNull TilePos tilePos, @NotNull Random rand, boolean isRandomTick)
-    {
-        TilePos up = tilePos.up();
-        if(world.isAirBlock(up))
-        {
+    public void updateTick(@NotNull World world, @NotNull TilePosc tilePos, @NotNull Random rand, boolean isRandomTick) {
+        TilePos up = tilePos.up(new TilePos());
+        if (world.isAirBlock(up)) {
             int reedHeight = 0;
             TilePos p = new TilePos(tilePos);
             while (world.getBlockId(p) == id()) { // Stop natural reed growth if reed is already 3 blocks tall
@@ -46,33 +43,30 @@ public class BlockLogicSugarcane extends BlockLogic implements IBonemealable
             }
 
             int data = world.getBlockData(tilePos);
-            if(data >= 15)
-            {
+            if (data >= 15) {
                 world.setBlockIdNotify(up, id());
                 world.setBlockDataNotify(tilePos, 0);
-            } else
-            {
+            } else {
                 world.setBlockDataNotify(tilePos, data + 1);
             }
         }
     }
 
-    public void growReedOnTop(@NotNull World world, @NotNull TilePos tilePos){
+    public void growReedOnTop(@NotNull World world, @NotNull TilePosc tilePos) {
         TilePos p = new TilePos(tilePos);
         while (world.getBlockId(p) == id()) {
             p.y++;
         }
-        if(world.isAirBlock(p)){
-                world.setBlockIdNotify(p, id());
-            }
+        if (world.isAirBlock(p)) {
+            world.setBlockIdNotify(p, id());
+        }
     }
 
     @Override
-	public boolean canPlaceAt(@NotNull World world, @NotNull TilePos tilePos)
-    {
-        TilePos down = tilePos.down();
-        Block<?> blockBelow = world.getBlock(down);
-        if(blockBelow == null) {
+    public boolean canPlaceAt(@NotNull World world, @NotNull TilePosc tilePos) {
+        TilePos queryPos = new TilePos();
+        Block<?> blockBelow = world.getBlock(tilePos.down(queryPos));
+        if (blockBelow == null) {
             return false;
         } else if (blockBelow.id() == id()) {
             return true;
@@ -80,68 +74,59 @@ public class BlockLogicSugarcane extends BlockLogic implements IBonemealable
             return false;
         }
         return
-            Blocks.hasTag(world.getBlockId(down.add(Direction.WEST)), BlockTags.IS_WATER) ||
-            Blocks.hasTag(world.getBlockId(down.add(Direction.EAST)), BlockTags.IS_WATER) ||
-            Blocks.hasTag(world.getBlockId(down.add(Direction.NORTH)), BlockTags.IS_WATER) ||
-            Blocks.hasTag(world.getBlockId(down.add(Direction.SOUTH)), BlockTags.IS_WATER);
+            Blocks.hasTag(world.getBlockId(tilePos.down(queryPos).add(Direction.WEST, queryPos)), BlockTags.IS_WATER) ||
+                Blocks.hasTag(world.getBlockId(tilePos.down(queryPos).add(Direction.EAST, queryPos)), BlockTags.IS_WATER) ||
+                Blocks.hasTag(world.getBlockId(tilePos.down(queryPos).add(Direction.NORTH, queryPos)), BlockTags.IS_WATER) ||
+                Blocks.hasTag(world.getBlockId(tilePos.down(queryPos).add(Direction.SOUTH, queryPos)), BlockTags.IS_WATER);
     }
 
     @Override
-	public void onNeighborChanged(@NotNull World world, @NotNull TilePos tilePos, int id)
-    {
+    public void onNeighborChanged(@NotNull World world, @NotNull TilePosc tilePos, int id) {
         checkCanStay(world, tilePos);
     }
 
-    protected final void checkCanStay(@NotNull World world, @NotNull TilePos tilePos)
-    {
-        if(!canStay(world, tilePos))
-        {
+    protected final void checkCanStay(@NotNull World world, @NotNull TilePosc tilePos) {
+        if (!canStay(world, tilePos)) {
             dropWithCause(world, EnumDropCause.WORLD, tilePos, world.getBlockData(tilePos), null, null);
             world.setBlockIdNotify(tilePos, 0);
         }
     }
 
     @Override
-    public ItemStack[] getBreakResult(@NotNull World world, @NotNull EnumDropCause dropCause, int data, @Nullable TileEntity tileEntity)
-    {
-        return new ItemStack[] { new ItemStack(Items.SUGARCANE) };
+    public ItemStack[] getBreakResult(@NotNull World world, @NotNull EnumDropCause dropCause, int data, @Nullable TileEntity tileEntity) {
+        return new ItemStack[]{new ItemStack(Items.SUGARCANE)};
     }
 
     @Override
-    public boolean canStay(@NotNull World world, @NotNull TilePos tilePos)
-    {
+    public boolean canStay(@NotNull World world, @NotNull TilePosc tilePos) {
         return canPlaceAt(world, tilePos);
     }
 
     @Override
-    public @Nullable AABB getCollisionAABB(@NotNull WorldSource source, @NotNull TilePos tilePos) {
+    public @Nullable AABBdc getCollisionAABB(@NotNull WorldSource source, @NotNull TilePosc tilePos) {
         return null;
     }
 
     @Override
-	public boolean isSolidRender()
-    {
+    public boolean isSolidRender() {
         return false;
     }
 
     @Override
-	public boolean isCubeShaped()
-    {
+    public boolean isCubeShaped() {
         return false;
     }
 
     @Override
-    public @NotNull ISupport getSupport(@NotNull World world, @NotNull TilePos tilePos, @NotNull Side side) {
+    public @NotNull ISupport getSupport(@NotNull World world, @NotNull TilePosc tilePos, @NotNull Side side) {
         return PartialSupport.INSTANCE;
     }
 
     @Override
-    public boolean onBonemealUsed(@NotNull ItemStack itemStack, @Nullable Player player, World world, @NotNull TilePos tilePos, @NotNull Side side, double xHit, double yHit) {
-        if(!world.isClientSide)
-        {
+    public boolean onBonemealUsed(@NotNull ItemStack itemStack, @Nullable Player player, World world, @NotNull TilePosc tilePos, @NotNull Side side, double xHit, double yHit) {
+        if (!world.isClientSide) {
             growReedOnTop(world, tilePos);
-            if (player == null || player.getGamemode().consumeBlocks())
-            {
+            if (player == null || player.getGamemode().consumeBlocks()) {
                 itemStack.stackSize--;
             }
         }
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicTNT.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicTNT.java
index 9e9365027..7ae29c260 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicTNT.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicTNT.java
@@ -1,6 +1,7 @@
 package net.minecraft.core.block;
 
 import net.minecraft.core.block.entity.TileEntity;
+import net.minecraft.core.block.material.Materials;
 import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.entity.EntityPrimedTNT;
 import net.minecraft.core.enums.EnumDropCause;
@@ -8,19 +9,18 @@ import net.minecraft.core.item.ItemFireStriker;
 import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.world.World;
-import net.minecraft.core.block.material.Material;
-import net.minecraft.core.world.pos.TilePos;
+import net.minecraft.core.world.pos.TilePosc;
 import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
 
 public class BlockLogicTNT extends BlockLogic {
 
 	public BlockLogicTNT(@NotNull Block<?> block) {
-		super(block, Material.explosive);
+		super(block, Materials.EXPLOSIVE);
 	}
 
 	@Override
-	public void onPlacedByWorld(@NotNull World world, @NotNull TilePos tilePos) {
+	public void onPlacedByWorld(@NotNull World world, @NotNull TilePosc tilePos) {
 		super.onPlacedByWorld(world, tilePos);
 		if (world.hasNeighborSignal(tilePos)) {
 			ignite(world, tilePos, true);
@@ -28,7 +28,7 @@ public class BlockLogicTNT extends BlockLogic {
 	}
 
 	@Override
-	public void onNeighborChanged(@NotNull World world, @NotNull TilePos tilePos, int id) {
+	public void onNeighborChanged(@NotNull World world, @NotNull TilePosc tilePos, int id) {
 		if (id > 0 && world.hasNeighborSignal(tilePos)) {
 			ignite(world, tilePos, true);
 		}
@@ -45,17 +45,17 @@ public class BlockLogicTNT extends BlockLogic {
 	}
 
 	@Override
-	public void onDestroyedByExplosion(@NotNull World world, @NotNull TilePos tilePos) {
-		EntityPrimedTNT entity = new EntityPrimedTNT(world, tilePos.x + 0.5F, tilePos.y + 0.5F, tilePos.z + 0.5F);
+	public void onDestroyedByExplosion(@NotNull World world, @NotNull TilePosc tilePos) {
+		EntityPrimedTNT entity = new EntityPrimedTNT(world, tilePos.x() + 0.5F, tilePos.y() + 0.5F, tilePos.z() + 0.5F);
 		entity.fuse = world.rand.nextInt(entity.fuse / 4) + entity.fuse / 8;
 		world.entityJoinedWorld(entity);
 	}
 
-	public void ignite(@NotNull World world, @NotNull TilePos tilePos, boolean sound) {
+	public void ignite(@NotNull World world, @NotNull TilePosc tilePos, boolean sound) {
 		ignite(world, null, tilePos, sound);
 	}
 
-	public void ignite(@NotNull World world, @Nullable Player player, @NotNull TilePos tilePos, boolean sound) {
+	public void ignite(@NotNull World world, @Nullable Player player, @NotNull TilePosc tilePos, boolean sound) {
 		if (world.isClientSide) {
 			if (player != null && player.inventory.getCurrentItem() != null && (player.inventory.getCurrentItem().getItem() instanceof ItemFireStriker)) {
 				player.inventory.getCurrentItem().damageItem(1, player);
@@ -63,7 +63,7 @@ public class BlockLogicTNT extends BlockLogic {
 			return;
 		}
 		world.setBlockIdNotify(tilePos, 0);
-		EntityPrimedTNT tnt = new EntityPrimedTNT(world, tilePos.x + 0.5F, tilePos.y + 0.5F, tilePos.z + 0.5F);
+		EntityPrimedTNT tnt = new EntityPrimedTNT(world, tilePos.x() + 0.5F, tilePos.y() + 0.5F, tilePos.z() + 0.5F);
 		world.entityJoinedWorld(tnt);
 		if (sound) world.playSoundAtEntity(null, tnt, "tile.tnt.fuse", 1.0F, 1.0F);
 		if (player != null && player.inventory.getCurrentItem() != null && (player.inventory.getCurrentItem().getItem() instanceof ItemFireStriker)) {
@@ -72,7 +72,7 @@ public class BlockLogicTNT extends BlockLogic {
 	}
 
 	@Override
-	public void onAttacked(@NotNull World world, @NotNull TilePos tilePos, @NotNull Player player, @NotNull Side side, double xHit, double yHit) {
+	public void onAttacked(@NotNull World world, @NotNull TilePosc tilePos, @NotNull Player player, @NotNull Side side, double xHit, double yHit) {
 		if (player.getCurrentEquippedItem() != null && player.getCurrentEquippedItem().getItem() instanceof ItemFireStriker) {
 			world.setBlockData(tilePos, 1);
 		}
@@ -80,7 +80,7 @@ public class BlockLogicTNT extends BlockLogic {
 	}
 
 	@Override
-	public boolean onInteracted(@NotNull World world, @NotNull TilePos tilePos, @NotNull Player player, @Nullable Side side, double xHit, double yHit) {
+	public boolean onInteracted(@NotNull World world, @NotNull TilePosc tilePos, @NotNull Player player, @Nullable Side side, double xHit, double yHit) {
 		if (player.inventory.getCurrentItem() != null && player.inventory.getCurrentItem().getItem() instanceof ItemFireStriker) {
 			ignite(world, player, tilePos, true);
 			return true;
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicTorch.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicTorch.java
index c1f043d9c..ad5b45705 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicTorch.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicTorch.java
@@ -1,23 +1,23 @@
 package net.minecraft.core.block;
 
-import net.minecraft.core.block.material.Material;
+import net.minecraft.core.block.material.Materials;
 import net.minecraft.core.block.support.ISupport;
 import net.minecraft.core.block.support.ISupportable;
 import net.minecraft.core.block.support.PartialSupport;
 import net.minecraft.core.entity.Mob;
 import net.minecraft.core.enums.EnumDropCause;
 import net.minecraft.core.util.helper.Side;
-import net.minecraft.core.util.phys.AABB;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.WorldSource;
-import net.minecraft.core.world.pos.TilePos;
+import net.minecraft.core.world.pos.TilePosc;
 import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
+import org.joml.primitives.AABBd;
+import org.joml.primitives.AABBdc;
 
 import java.util.Random;
 
-public class BlockLogicTorch extends BlockLogic implements ISupportable
-{
+public class BlockLogicTorch extends BlockLogic implements ISupportable {
     public static final int MASK_DIRECTION = 0b0000_0111;
     public static final int SIDE_NONE = 0;
     public static final int SIDE_WEST = 1;
@@ -27,48 +27,44 @@ public class BlockLogicTorch extends BlockLogic implements ISupportable
     public static final int SIDE_BOTTOM = 5;
     public static final int SIDE_TOP = 6;
 
-	public BlockLogicTorch(@NotNull Block<?> block)
-    {
-        super(block, Material.decoration);
+    public BlockLogicTorch(@NotNull Block<?> block) {
+        super(block, Materials.DECORATION);
         block.setTicking(true);
     }
 
     @Override
-    public @Nullable AABB getCollisionAABB(@NotNull WorldSource source, @NotNull TilePos tilePos) {
+    public @Nullable AABBdc getCollisionAABB(@NotNull WorldSource source, @NotNull TilePosc tilePos) {
         return null;
     }
 
     @Override
-    public @NotNull AABB getBoundsFromState(@NotNull WorldSource world, @NotNull TilePos tilePos) {
+    public @NotNull AABBdc getBoundsFromState(@NotNull WorldSource world, @NotNull TilePosc tilePos) {
         float f = 0.15F;
         int side = world.getBlockData(tilePos) & MASK_DIRECTION;
         return switch (side) {
-            case SIDE_WEST -> AABB.fromPool(0.0F, 0.2F, 0.5F - f, f * 2.0F, 0.8F, 0.5F + f);
-            case SIDE_EAST -> AABB.fromPool(1.0F - f * 2.0F, 0.2F, 0.5F - f, 1.0F, 0.8F, 0.5F + f);
-            case SIDE_NORTH -> AABB.fromPool(0.5F - f, 0.2F, 0.0F, 0.5F + f, 0.8F, f * 2.0F);
-            case SIDE_SOUTH -> AABB.fromPool(0.5F - f, 0.2F, 1.0F - f * 2.0F, 0.5F + f, 0.8F, 1.0F);
+            case SIDE_WEST -> new AABBd(0.0F, 0.2F, 0.5F - f, f * 2.0F, 0.8F, 0.5F + f);
+            case SIDE_EAST -> new AABBd(1.0F - f * 2.0F, 0.2F, 0.5F - f, 1.0F, 0.8F, 0.5F + f);
+            case SIDE_NORTH -> new AABBd(0.5F - f, 0.2F, 0.0F, 0.5F + f, 0.8F, f * 2.0F);
+            case SIDE_SOUTH -> new AABBd(0.5F - f, 0.2F, 1.0F - f * 2.0F, 0.5F + f, 0.8F, 1.0F);
             default -> {
                 final float f1 = 0.1F;
-                yield AABB.fromPool(0.5F - f1, 0.0F, 0.5F - f1, 0.5F + f1, 0.6F, 0.5F + f1);
+                yield new AABBd(0.5F - f1, 0.0F, 0.5F - f1, 0.5F + f1, 0.6F, 0.5F + f1);
             }
         };
     }
 
     @Override
-	public boolean isSolidRender()
-    {
+    public boolean isSolidRender() {
         return false;
     }
 
     @Override
-	public boolean isCubeShaped()
-    {
+    public boolean isCubeShaped() {
         return false;
     }
 
     @Override
-	public boolean canPlaceAt(@NotNull World world, @NotNull TilePos tilePos)
-    {
+    public boolean canPlaceAt(@NotNull World world, @NotNull TilePosc tilePos) {
         return isSupported(world, tilePos, Side.BOTTOM)
             || isSupported(world, tilePos, Side.NORTH)
             || isSupported(world, tilePos, Side.SOUTH)
@@ -77,38 +73,38 @@ public class BlockLogicTorch extends BlockLogic implements ISupportable
     }
 
     @Override
-    public void onPlacedByMob(@NotNull World world, @NotNull TilePos tilePos, @NotNull Side side, @NotNull Mob mob, double xHit, double yHit) {
+    public void onPlacedByMob(@NotNull World world, @NotNull TilePosc tilePos, @NotNull Side side, @NotNull Mob mob, double xHit, double yHit) {
         if (side.isHorizontal()) side = side.getOpposite();
         onPlacedOnSide(world, tilePos, side, xHit, yHit);
     }
 
     @Override
-    public void onPlacedOnSide(@NotNull World world, @NotNull TilePos tilePos, @NotNull Side side, double xHit, double yHit) {
+    public void onPlacedOnSide(@NotNull World world, @NotNull TilePosc tilePos, @NotNull Side side, double xHit, double yHit) {
         int orientation = SIDE_NONE;
         if (side.isHorizontal()) side = side.getOpposite();
         switch (side) {
             case TOP:
-                if(isSupported(world, tilePos, Side.BOTTOM)) {
+                if (isSupported(world, tilePos, Side.BOTTOM)) {
                     orientation = SIDE_BOTTOM;
                 }
                 break;
             case NORTH:
-                if(isSupported(world, tilePos, Side.SOUTH)) {
+                if (isSupported(world, tilePos, Side.SOUTH)) {
                     orientation = SIDE_SOUTH;
                 }
                 break;
             case SOUTH:
-                if(isSupported(world, tilePos, Side.NORTH)) {
+                if (isSupported(world, tilePos, Side.NORTH)) {
                     orientation = SIDE_NORTH;
                 }
                 break;
             case WEST:
-                if(isSupported(world, tilePos, Side.EAST)) {
+                if (isSupported(world, tilePos, Side.EAST)) {
                     orientation = SIDE_EAST;
                 }
                 break;
             case EAST:
-                if(isSupported(world, tilePos, Side.WEST)) {
+                if (isSupported(world, tilePos, Side.WEST)) {
                     orientation = SIDE_WEST;
                 }
                 break;
@@ -120,34 +116,31 @@ public class BlockLogicTorch extends BlockLogic implements ISupportable
         dropTorchIfCantStay(world, tilePos);
     }
 
-    public int getDefaultOrientation(@NotNull World world, @NotNull TilePos tilePos) {
-        if(isSupported(world, tilePos, Side.BOTTOM)) {
+    public int getDefaultOrientation(@NotNull World world, @NotNull TilePosc tilePos) {
+        if (isSupported(world, tilePos, Side.BOTTOM)) {
             return SIDE_BOTTOM;
-        } else if(isSupported(world, tilePos, Side.WEST)) {
+        } else if (isSupported(world, tilePos, Side.WEST)) {
             return SIDE_WEST;
-        } else if(isSupported(world, tilePos, Side.EAST)) {
+        } else if (isSupported(world, tilePos, Side.EAST)) {
             return SIDE_EAST;
-        } else if(isSupported(world, tilePos, Side.NORTH)) {
+        } else if (isSupported(world, tilePos, Side.NORTH)) {
             return SIDE_NORTH;
-        } else if(isSupported(world, tilePos, Side.SOUTH)) {
+        } else if (isSupported(world, tilePos, Side.SOUTH)) {
             return SIDE_SOUTH;
         }
         return SIDE_NONE;
     }
-    
+
     @Override
-	public void updateTick(@NotNull World world, @NotNull TilePos tilePos, @NotNull Random rand, boolean isRandomTick)
-    {
+    public void updateTick(@NotNull World world, @NotNull TilePosc tilePos, @NotNull Random rand, boolean isRandomTick) {
         super.updateTick(world, tilePos, rand, isRandomTick);
-        if(world.getBlockData(tilePos) == SIDE_NONE)
-        {
+        if (world.getBlockData(tilePos) == SIDE_NONE) {
             onPlacedByWorld(world, tilePos);
         }
     }
 
     @Override
-	public void onPlacedByWorld(@NotNull World world, @NotNull TilePos tilePos)
-    {
+    public void onPlacedByWorld(@NotNull World world, @NotNull TilePosc tilePos) {
         int orientation = getDefaultOrientation(world, tilePos);
         if (orientation != SIDE_NONE) {
             world.setBlockDataNotify(tilePos, orientation);
@@ -156,7 +149,7 @@ public class BlockLogicTorch extends BlockLogic implements ISupportable
     }
 
     @Override
-    public void onNeighborChanged(@NotNull World world, @NotNull TilePos tilePos, int id) {
+    public void onNeighborChanged(@NotNull World world, @NotNull TilePosc tilePos, int id) {
         boolean invalid;
         int side = world.getBlockData(tilePos) & MASK_DIRECTION;
         invalid = switch (side) {
@@ -167,27 +160,24 @@ public class BlockLogicTorch extends BlockLogic implements ISupportable
             case SIDE_BOTTOM -> !isSupported(world, tilePos, Side.BOTTOM);
             default -> true;
         };
-        if(invalid)
-        {
+        if (invalid) {
             dropWithCause(world, EnumDropCause.WORLD, tilePos, side, null, null);
             world.setBlockIdNotify(tilePos, 0);
         }
     }
 
-    private void dropTorchIfCantStay(@NotNull World world, @NotNull TilePos tilePos)
-    {
-        if(!canPlaceAt(world, tilePos)) {
+    private void dropTorchIfCantStay(@NotNull World world, @NotNull TilePosc tilePos) {
+        if (!canPlaceAt(world, tilePos)) {
             dropWithCause(world, EnumDropCause.WORLD, tilePos, world.getBlockData(tilePos), null, null);
             world.setBlockIdNotify(tilePos, 0);
         }
     }
 
     @Override
-	public void animationTick(@NotNull World world, @NotNull TilePos tilePos, @NotNull Random rand)
-    {
-        double xPos = (double) tilePos.x + 0.5D;
-        double yPos = (double) tilePos.y + 0.7D;
-        double zPos = (double) tilePos.z + 0.5D;
+    public void animationTick(@NotNull World world, @NotNull TilePosc tilePos, @NotNull Random rand) {
+        double xPos = (double) tilePos.x() + 0.5D;
+        double yPos = (double) tilePos.y() + 0.7D;
+        double zPos = (double) tilePos.z() + 0.5D;
         double d3 = 0.22D;
         double d4 = 0.27D;
         int side = world.getBlockData(tilePos) & MASK_DIRECTION;
@@ -214,19 +204,19 @@ public class BlockLogicTorch extends BlockLogic implements ISupportable
                 break;
         }
     }
-    
+
     @Override
-    public int getLightmapCoord(@NotNull WorldSource source, @NotNull TilePos tilePos) {
-		return source.getLightmapCoord(tilePos, this.block.emission > 0 ? 15 : 0);
+    public int getLightmapCoord(@NotNull WorldSource source, @NotNull TilePosc tilePos) {
+        return source.getLightmapCoord(tilePos, this.block.emission > 0 ? 15 : 0);
     }
 
     @Override
-    public @NotNull ISupport getSupport(@NotNull World world, @NotNull TilePos tilePos, @NotNull Side side) {
+    public @NotNull ISupport getSupport(@NotNull World world, @NotNull TilePosc tilePos, @NotNull Side side) {
         return PartialSupport.INSTANCE;
     }
 
     @Override
-    public @NotNull ISupport getSupportConstraint(@NotNull World world, @NotNull TilePos tilePos, @NotNull Side side) {
+    public @NotNull ISupport getSupportConstraint(@NotNull World world, @NotNull TilePosc tilePos, @NotNull Side side) {
         return switch (side) {
             case NORTH, SOUTH, WEST, EAST, BOTTOM -> PartialSupport.INSTANCE.center();
             default -> PartialSupport.INSTANCE;
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicTorchRedstone.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicTorchRedstone.java
index ea49fdb67..7d35b4547 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicTorchRedstone.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicTorchRedstone.java
@@ -7,6 +7,7 @@ import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.WorldSource;
 import net.minecraft.core.world.pos.TilePos;
+import net.minecraft.core.world.pos.TilePosc;
 import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
 
@@ -27,34 +28,36 @@ public class BlockLogicTorchRedstone extends BlockLogicTorch {
     }
 
     @Override
-    public void onPlacedByWorld(@NotNull World world, @NotNull TilePos tilePos) {
+    public void onPlacedByWorld(@NotNull World world, @NotNull TilePosc tilePos) {
         if (world.getBlockData(tilePos) == SIDE_NONE) {
             super.onPlacedByWorld(world, tilePos);
         }
+        TilePos queryPos = new TilePos();
         if (this.torchActive) {
-            world.notifyBlocksOfNeighborChange(tilePos.down(), id());
-            world.notifyBlocksOfNeighborChange(tilePos.up(), id());
-            world.notifyBlocksOfNeighborChange(tilePos.west(), id());
-            world.notifyBlocksOfNeighborChange(tilePos.east(), id());
-            world.notifyBlocksOfNeighborChange(tilePos.north(), id());
-            world.notifyBlocksOfNeighborChange(tilePos.south(), id());
+            world.notifyBlocksOfNeighborChange(tilePos.down(queryPos), id());
+            world.notifyBlocksOfNeighborChange(tilePos.up(queryPos), id());
+            world.notifyBlocksOfNeighborChange(tilePos.west(queryPos), id());
+            world.notifyBlocksOfNeighborChange(tilePos.east(queryPos), id());
+            world.notifyBlocksOfNeighborChange(tilePos.north(queryPos), id());
+            world.notifyBlocksOfNeighborChange(tilePos.south(queryPos), id());
         }
     }
 
     @Override
-    public void onRemoved(@NotNull World world, @NotNull TilePos tilePos, int data) {
+    public void onRemoved(@NotNull World world, @NotNull TilePosc tilePos, int data) {
+        TilePos queryPos = new TilePos();
         if (this.torchActive) {
-            world.notifyBlocksOfNeighborChange(tilePos.down(), id());
-            world.notifyBlocksOfNeighborChange(tilePos.up(), id());
-            world.notifyBlocksOfNeighborChange(tilePos.west(), id());
-            world.notifyBlocksOfNeighborChange(tilePos.east(), id());
-            world.notifyBlocksOfNeighborChange(tilePos.north(), id());
-            world.notifyBlocksOfNeighborChange(tilePos.south(), id());
+            world.notifyBlocksOfNeighborChange(tilePos.down(queryPos), id());
+            world.notifyBlocksOfNeighborChange(tilePos.up(queryPos), id());
+            world.notifyBlocksOfNeighborChange(tilePos.west(queryPos), id());
+            world.notifyBlocksOfNeighborChange(tilePos.east(queryPos), id());
+            world.notifyBlocksOfNeighborChange(tilePos.north(queryPos), id());
+            world.notifyBlocksOfNeighborChange(tilePos.south(queryPos), id());
         }
     }
 
     @Override
-    public boolean isEmittingSignal(@NotNull WorldSource source, @NotNull TilePos tilePos, @NotNull Side side) {
+    public boolean isEmittingSignal(@NotNull WorldSource source, @NotNull TilePosc tilePos, @NotNull Side side) {
         if (!this.torchActive) {
             return false;
         }
@@ -69,20 +72,20 @@ public class BlockLogicTorchRedstone extends BlockLogicTorch {
         };
     }
 
-    private boolean hasNeighborSignal(World world, @NotNull TilePos tilePos) {
+    private boolean hasNeighborSignal(World world, @NotNull TilePosc tilePos) {
         int direction = world.getBlockData(tilePos) & MASK_DIRECTION;
         return switch (direction) {
-            case SIDE_BOTTOM -> world.hasSignal(tilePos.down(), Side.BOTTOM);
-            case SIDE_SOUTH -> world.hasSignal(tilePos.south(), Side.SOUTH);
-            case SIDE_NORTH -> world.hasSignal(tilePos.north(), Side.NORTH);
-            case SIDE_EAST -> world.hasSignal(tilePos.east(), Side.EAST);
-            case SIDE_WEST -> world.hasSignal(tilePos.west(), Side.WEST);
+            case SIDE_BOTTOM -> world.hasSignal(tilePos.down(new TilePos()), Side.BOTTOM);
+            case SIDE_SOUTH -> world.hasSignal(tilePos.south(new TilePos()), Side.SOUTH);
+            case SIDE_NORTH -> world.hasSignal(tilePos.north(new TilePos()), Side.NORTH);
+            case SIDE_EAST -> world.hasSignal(tilePos.east(new TilePos()), Side.EAST);
+            case SIDE_WEST -> world.hasSignal(tilePos.west(new TilePos()), Side.WEST);
             default -> false;
         };
     }
 
     @Override
-    public void updateTick(@NotNull World world, @NotNull TilePos tilePos, @NotNull Random rand, boolean isRandomTick) {
+    public void updateTick(@NotNull World world, @NotNull TilePosc tilePos, @NotNull Random rand, boolean isRandomTick) {
         boolean isPowered = hasNeighborSignal(world, tilePos);
         if (this.torchActive) {
             if (isPowered) {
@@ -94,13 +97,13 @@ public class BlockLogicTorchRedstone extends BlockLogicTorch {
     }
 
     @Override
-    public void onNeighborChanged(@NotNull World world, @NotNull TilePos tilePos, int id) {
+    public void onNeighborChanged(@NotNull World world, @NotNull TilePosc tilePos, int id) {
         super.onNeighborChanged(world, tilePos, id);
         world.scheduleBlockUpdate(tilePos, id(), tickDelay());
     }
 
     @Override
-    public boolean isEmittingDirectSignal(@NotNull World world, @NotNull TilePos tilePos, @NotNull Side side) {
+    public boolean isEmittingDirectSignal(@NotNull World world, @NotNull TilePosc tilePos, @NotNull Side side) {
         if (side == Side.BOTTOM) {
             return isEmittingSignal(world, tilePos, side);
         } else {
@@ -119,15 +122,15 @@ public class BlockLogicTorchRedstone extends BlockLogicTorch {
     }
 
     @Override
-    public void animationTick(@NotNull World world, @NotNull TilePos tilePos, @NotNull Random rand) {
+    public void animationTick(@NotNull World world, @NotNull TilePosc tilePos, @NotNull Random rand) {
         if (!this.torchActive) {
             return;
         }
 
         int direction = world.getBlockData(tilePos) & MASK_DIRECTION;
-        double px = (tilePos.x + 0.5D) + (rand.nextFloat() - 0.5D) * 0.2D;
-        double py = (tilePos.y + 0.7D) + (rand.nextFloat() - 0.5D) * 0.2D;
-        double pz = (tilePos.z + 0.5D) + (rand.nextFloat() - 0.5D) * 0.2D;
+        double px = (tilePos.x() + 0.5D) + (rand.nextFloat() - 0.5D) * 0.2D;
+        double py = (tilePos.y() + 0.7D) + (rand.nextFloat() - 0.5D) * 0.2D;
+        double pz = (tilePos.z() + 0.5D) + (rand.nextFloat() - 0.5D) * 0.2D;
 
         double verticalOffset = 0.22D;
         double horizontalOffset = 0.27D;
